' DISCLAIMER - USE AT OWN RISK

Dim ev$ : Dim R1 : Dim R2 : Dim R3
Dim R4 : Dim K$ : R4 = 0
Dim looper : Dim HVfan : Dim fanspeed 
Dim stepper : stepper = 0
Dim looper : R1=0 : fanspeed = 0
Dim ok : Dim rxOk : Dim txOk


Sub Chconfig
  CAN CONFIG ok
  CAN SETSPEED 500000, ok
  CAN ADDTXCHNL 0,1,txOk
  CAN ADDRXCHNL 1,&h7EB,0,1,rxOk         
  CAN ENABLE ok
End Sub


Sub drawBoxes
  Line(115,45)-(170,77),1,B : Print @(132,50) "F10  ";
  Print @(120,65) "FAN AUTO";
End Sub


Sub setrelays
  SetPin 15,9 : SetPin 16,9 : SetPin 17,9 : SetPin 18,9
  Pin(15) = 0 : Pause 10    : Pin(15) = 1
  Pin(16) = 1 : Pin(17) = 1 : Pin(18) = 1 : Pause 1000 : Pin(18) = R4
End Sub


Sub UpdateF10
    Local rxData(8) : Local rxOk
    Local txData(8) : Local txOk : Local inLoop : inLoop = 0
    txData(0) = &H4 : txData(1) = &H30 : txData(2) = &H81 : txData(3) = 6
    txData(4) = fanspeed : txData(5) = 0 : txData(6) = 0 : txData(7) = 0
    If HVfan = 1 Then
      CAN TX 0, &H7E3, 0, 8, txData(), txOk : ' HV FAN MANUAL MODE
      If txOk = 1 Then
        Do
          CAN RX 1, RxData(8), rxOk
          If (rxOK = 1) Then
            If (rxData(0) = &H2 And rxData(1) = &H70) Then
              Font 1 : Print @(120,65) "HV FAN";fanspeed : Exit Sub
            EndIf
          EndIf
          If inLoop > 50 Then CAN DISABLE ok : Exit Sub
          inLoop = inLoop + 1
        Loop
      EndIf
    EndIf
    If HVfan = 0 Then
      If page <> 7 Then
        Font 1 : Print @(120,65) "FAN AUTO";
      EndIf
      If (BatDegCh > 25) Then
        txData(4) = 6 : CAN TX 0, &H7E3, 0, 8, txData(), txOk : ' HV FAN AUTO MODE
        If txOk = 1 Then
          Do
            CAN RX 1, RxData(8), rxOk
            If (rxOK = 1) Then
              If (rxData(0) = &H2 And rxData(1) = &H70) Then Exit Sub
            EndIf
            If inLoop > 50 Then Exit Sub
            inLoop = inLoop + 1
          Loop
        EndIf
      EndIf
    EndIf
End Sub


Sub F10
  If HVfan = 0 Then HVfan = 1 Else HVfan = 0 : ' HVfan = 1 - MANUAL MODE = 0 - AUTO MODE
End Sub


Sub Updatehvfan
  Font 2
  If HVfan = 0 And (BatDegCh > 25) Then
    Font 2, ,1 : Print @(172,53) "     "; @(172,53) Format$(BatDegCh,"% g");
    Font 1, ,1 : Print "o"; : Font 2, ,1 : Print "C";
  EndIf
  If HVfan = 0 And (BatDegCh =< 25) Then
    Font 2 : Print @(172,53) "     "; @(172,53) Format$(BatDegCh,"% g");
    Font 1 : Print "o"; : Font 2 : Print "C";
  EndIf
  If HVfan = 1 Then
    Font 2 : Print @(172,53) "     "; @(172,53) Format$(BatDegCh,"% g");
    Font 1 : Print "o"; : Font 2 : Print "C";
  EndIf
End Sub



'''''''''''''
' MAIN Starts here
Cls
LoadBMP "logo.bmp",30,30
Pause 1000
Cls
printHeader()
drawBoxes() 
setrelays()
looper = 0
Chconfig()
Do
  K$ = Inkey$
  If K$ = "q" Then exit
  If K$ = Chr$(154) Then F10() : ' HV FAN AUTO/MANUAL BUTTON - Pressing F10 toggles beteen AUTO and MANUAL mode for HV battery fan
  If K$ = Chr$(48) Then fanspeed = 0 : ' Press the number 0 key and fanspeed setting is 0 if HVFAN is in manual mode
  If K$ = Chr$(49) Then fanspeed = 1 : ' Press the number 1 key and fanspeed setting is 1 if HVFAN is in manual mode
  If K$ = Chr$(50) Then fanspeed = 2 : ' Press the number 2 key and fanspeed setting is 2 if HVFAN is in manual mode
  If K$ = Chr$(51) Then fanspeed = 3 : ' Press the number 3 key and fanspeed setting is 3 if HVFAN is in manual mode
  If K$ = Chr$(52) Then fanspeed = 4 : ' Press the number 4 key and fanspeed setting is 4 if HVFAN is in manual mode
  If K$ = Chr$(53) Then fanspeed = 5 : ' Press the number 5 key and fanspeed setting is 5 if HVFAN is in manual mode
  If K$ = Chr$(54) Then fanspeed = 6 : ' Press the number 6 key and fanspeed setting is 6 if HVFAN is in manual mode
' If HV battery fan speed less than 5 then set speed to six after a period of time
  If HVfan = 1 Then
    stepper = stepper + 1
    If stepper > 50 Then fanspeed = 6 : stepper = 0
  EndIf
  If (looper = 2) Then updateF10()
  updatehvfan()
  Font 2 : Print @(260,404) looper; : looper = looper + 1
  If looper => 6 Then looper = 0 
Loop
  
CAN FREE
Cls
Print "        CANPORT CLOSED"
