' DISCLAIMER - USE AT OWN RISK

Dim looper : Dim MG1t : Dim MG2t : Dim INV1t : Dim k$
Dim INV2t : Dim MG1rpm : Dim MG2rpm : Dim MG1TQ : Dim MG2TQ
Dim R1 : Dim R2 : Dim R3 : Dim R4
Dim ok : Dim txOk : Dim rxOk


Sub Chconfig
  CAN CONFIG ok
  CAN SETSPEED 500000, ok
  CAN ADDTXCHNL 0,1,txOk
  CAN ADDRXCHNL 1,&h7EA,0,1,rxOk
  CAN ENABLE ok
End Sub


Sub filter21C3
Local rxData(8) : Local rxOk
CAN RX 1, rxData(8), rxOk
If rxok = 1 Then
  If (rxData(0) = &H21) Then
    D3 = 1 : MG1rpm = ((rxData(3) * 256) + rxData(4)) - 16383
    MG1TQ = (32 * rxData(5) ) + (0.125 * rxData(6)) - 500 : G = rxData(7)
  EndIf
  If (rxData(0) = &H23) Then INV1t = rxData(7) - 50 : D4 = 1
  If (rxData(0) = &H24) Then
    D5 = 1 : INV2t = rxData(1) - 50 : MG2t = rxData(2) - 50 : MG1t = rxData(3) - 50
  EndIf
EndIf
End Sub

Function pidrequest21C3
  Local rxData(8) : Local rxOk
  Local d1 : Local d2 : Local d3 : Local d4 : Local d5 : Local d6
  Local onLoop : Local bloop : Local txData(8) : Local txok
  d1=0 : d2=0 : d3=0 : d4=0 : d5=0 : d6=0 : onLoop = 0 : bloop = 0
  pidrequest = 0 : txData(3) = 0 : txData(4) = 0 : txData(5) = 0 
  txData(6) = 0 : txData(7) = 0 : txData(0) = &H2 : txData(1) = &H21 : txData(2) = &HC3
Do
  D1 = 0 : D2 = 0 : D3 = 0 : D4 = 0 : D5 = 0 : D6 = 0
  CAN TX 0, &H7E2, 0, 8, txData(), txOk
  If txok = 1 Then
    D1 = 1 : CAN RX 1, rxData(8), rxOk
    If rxOk = 1 Then
      If (rxData(0) = &H10) Then
        MG2TQ = (32 * rxData(6) ) + (0.125 * rxData(7)) - 500
        MG2rpm = ((256 * rxData(4)) + rxData(5)) - 16383
        txData(0)=&H30 : txData(1)=0 : txData(2)=0 : D2 = 1
        Do
          CAN TX 0, &H7E2, 0, 8, txData(), txOk
          If txOk = 1 And D3 = 0 Then filter21C3()
          If D3 = 0 Or D4 = 0 Or D5 = 0 Then filter21C3()
          If D3 = 0 Or D4 = 0 Or D5 = 0 Then filter21C3()
          If D3 = 0 Or D4 = 0 Or D5 = 0 Then filter21C3()
          If D3=1 And D4=1 And D5=1 Then 
            pidrequest21C3 = 1 
            Exit Function
          Endif
          bloop = bloop + 1
          If bloop > 30 Then Exit Function
        Loop
      EndIf
    EndIf
  EndIf
  If D3=1 And D4=1 And D5=1 Then 
    pidrequest21C3 = 1
    Exit Function
  Endif
  If onloop > 50 Then Exit Function
  onLoop = onLoop + 1
Loop
End Function


Sub update21C3
  Font 2
  Font 2 : Print @(60,110)  "     "; @(60,110) Format$(MG1t,"% g");
  Font 1 : Print "o"; : Font 2 : Print "C";
  Print @(180,110) "     "; @(180,110) Format$(MG2t,"% g");
  Font 1 : Print "o"; : Font 2 : Print "C";
  Print @(60,130)  "     "; @(60,130) Format$(INV1t,"% g");
  Font 1 : Print "o"; : Font 2 : Print "C";
  Print @(180,130) "     "; @(180,130) Format$(INV2t,"% g");
  Print @(60,270)   "        "; @(60,270) Format$(MG1TQ,"% .0f"); " NM";
  Print @(60,290)   "        "; @(60,290) Format$(MG2TQ,"% .0f"); " NM";
  Print @(60,310)   "          "; @(60,310) Format$(MG1rpm,"% g"); " rpm";
  Print @(60,330)   "          "; @(60,330) Format$(MG2rpm,"% g"); " rpm";
End Sub


Sub printHeader
  Cls : Font 2 : Print @(15,0) "DUINOMITE-CANVIEW V4/BMS+ PRIUS G2";
End Sub


Sub setrelays
  SetPin 15,9 : SetPin 16,9 : SetPin 17,9 : SetPin 18,9
  Pin(15) = 0 : Pause 10    : Pin(15) = 1
  Pin(16) = 1 : Pin(17) = 1 : Pin(18) = 1 : Pause 1000 : Pin(18) = R4
End Sub


'''''''''''''
' MAIN Starts here
Cls
LoadBMP "logo.bmp",30,30
Pause 1000 
Cls 
printHeader() 
drawlabels_lhs() 
setrelays() 
looper = 0
Chconfig()
Do
 K$ = Inkey$
  If K$ = "q" Then Exit
  If If (pidrequest21C3()=1) Then update21C3()
  Font 2
  Print @(260,404) looper; 
  looper = looper + 1
  If looper => 6 Then looper = 0 
Loop

CAN FREE
Cls
Print "        CANPORT CLOSED"
