' DISCLAIMER - USE AT OWN RISK

Dim R1 : Dim R2 : Dim R3 : Dim R4 : Dim K$ 
Dim looper : R1=0 : R4 = 0
Dim HVB1 : Dim HVB2 : Dim HVB3 : Dim HVB4 : Dim HVB5 : Dim HVB6 : Dim HVB7 
Dim HVB8 : Dim HVB9 : Dim HVB10 : Dim HVB11 : Dim HVB12 : Dim HVB13 : Dim HVB14 : Dim HVBT
Dim ok : Dim txOk : Dim rxOk


Sub Chconfig
  CAN CONFIG ok
  CAN SETSPEED 500000, ok
  CAN ADDTXCHNL 0,1,txOk
  CAN ADDRXCHNL 1,&h7EB,0,1,rxOk         
  CAN ENABLE ok
End Sub


Sub setrelays
  SetPin 15,9 : SetPin 16,9 : SetPin 17,9 : SetPin 18,9
  Pin(15) = 0 : Pause 10    : Pin(15) = 1
  Pin(16) = 1 : Pin(17) = 1 : Pin(18) = 1 : Pause 1000 : Pin(18) = R4
End Sub


Sub Filter21CE
  Local rxId : Local rxType : Local rxLen : Local rxData(8) : Local rxOk
  CAN RX 1, rxData(8), rxOk
  If rxok = 1 Then
    If D3 = 0 And (rxData(0) = &H21) Then
      D3 = 1 : HVB1 = (2.56 * HVB1MEM) + (0.01 * rxData(1)) - 327.68
      HVB2 = (2.56 * rxData(2)) + (0.01 * rxData(3)) - 327.68
      HVB3 = (2.56 * rxData(4)) + (0.01 * rxData(5)) - 327.68
      HVB4 = (2.56 * rxData(6)) + (0.01 * rxData(7)) - 327.68
    EndIf
    If D4 = 0 And (rxData(0) = &H22) Then
      D4 = 1 : HVB5 = (2.56 * rxData(1)) + (0.01 * rxData(2)) - 327.68
      HVB6 = (2.56 * rxData(3)) + (0.01 * rxData(4)) - 327.68
      HVB7 = (2.56 * rxData(5)) + (0.01 * rxData(6)) - 327.68
      HVB8MEM = rxData(7)
    EndIf
    If D5 = 0 And (rxData(0) = &H23) Then
      If HVB8MEM > 0 Then
         HVB8 = (2.56 * HVB8MEM) + (0.01 * rxData(1)) - 327.68
      EndIf
      HVB9 = (2.56 * rxData(2)) + (0.01 * rxData(3)) - 327.68
      HVB10 = (2.56 * rxData(4)) + (0.01 * rxData(5)) - 327.68
      HVB11 = (2.56 * rxData(6)) + (0.01 * rxData(7)) - 327.68 : D5 = 1
    EndIf
    If D6 = 0 And (rxData(0) = &H24) Then
      D6 = 1 : HVB12 = (2.56 * rxData(1)) + (0.01 * rxData(2)) - 327.68
      HVB13 = (2.56 * rxData(3)) + (0.01 * rxData(4)) - 327.68
      HVB14 = (2.56 * rxData(5)) + (0.01 * rxData(6)) - 327.68
    EndIf
  EndIf
End Sub


Function pidrequest21CE
' Function to get 14 x HV battery block voltages
  Local rxData(8) : Local rxOk
  Dim d1 : Dim d2 : Dim d3 : Dim d4 : Dim d5 : Dim d6 : Dim HVB1MEM : Dim HVB8MEM
  Local txData(8) : Local txok : d1=0 : d2=0 : d3=0 : d4=0 : d5=0 : d6=0
  Local onLoop : Local bloop : onLoop = 0 : bloop = 0 : HVB8MEM = 0 : HVB1MEM = 0
  txData(3) = 0 : txData(4) = 0 : txData(5) = 0 : txData(6) = 0 : txData(7) = 0
  txData(0) = &H2 : txData(1) = &H21 : txData(2) = &HCE
Do
  d1=0 : d2=0 : d3=0 : d4=0 : d5=0 : d6=0 : CAN TX 0, &H7E3, 0, 8, txData(), txOk
  If txok = 1 Then
    CAN RX 1, rxData(8), rxOk
    If rxOk = 1 Then
      If (rxData(0) = &H10) Then
        HVB1MEM = rxData(7) : txData(0)=&H30 : txData(1)=0 : txData(2)=1
        Do
          CAN TX 0, &H7E3, 0, 8, txData(), txOk
          If txOk = 1 And d2 = 0 Then filter21ce()
          If D3 = 0 Or D4 = 0 Or D5 = 0 Or D6 = 0 Then filter21CE()
          If D3 = 0 Or D4 = 0 Or D5 = 0 Or D6 = 0 Then filter21CE()
          If D3 = 0 Or D4 = 0 Or D5 = 0 Or D6 = 0 Then filter21CE()
          If D3 = 0 Or D4 = 0 Or D5 = 0 Or D6 = 0 Then filter21CE()
          If D3=1 And D4=1 And D5=1 And D6=1 Then
            HVBT = HVB1+HVB2+HVB3+HVB4+HVB5+HVB6+HVB7+HVB8+HVB9+HVB10+HVB11+HVB12+HVB13+HVB14
            pidrequest21CE = 1 : Exit Function
          EndIf
          bloop = bloop + 1
          HVBT=HVB1+HVB2+HVB3+HVB4+HVB5+HVB6+HVB7+HVB8+HVB9+HVB10+HVB11+HVB12+HVB13+HVB14
          If bloop > 120 Then Exit Function
        Loop
      EndIf
    EndIf
  EndIf
  If D3=1 And D4=1 And D5=1 And D6=1 Then
    pidrequest21CE = 1
    HVBT = HVB1+HVB2+HVB3+HVB4+HVB5+HVB6+HVB7+HVB8+HVB9+HVB10+HVB11+HVB12+HVB13+HVB14
    Exit Function
  EndIf
  HVBT=HVB1+HVB2+HVB3+HVB4+HVB5+HVB6+HVB7+HVB8+HVB9+HVB10+HVB11+HVB12+HVB13+HVB14
  If onloop > 120 Then Exit Function
  onLoop = onLoop + 1
Loop
End Function


Sub updateF5
  Font 2
  Print @(35,130)  "       "; @(35,130)   Format$(HVB1,"%g"); "v";
  Print @(155,130) "       "; @(155,130)  Format$(HVB2,"%g"); "v";
  Print @(35,150)  "       "; @(35,150)  Format$(HVB3,"%g") ; "v";
  Print @(155,150) "       "; @(155,150) Format$(HVB4,"%g") ; "v";
  Print @(35,170)  "       "; @(35,170)  Format$(HVB5,"%g") ; "v";
  Print @(155,170) "       "; @(155,170) Format$(HVB6,"%g") ; "v";
  Print @(35,190)  "       "; @(35,190)  Format$(HVB7,"%g") ; "v";
  Print @(155,190) "       "; @(155,190) Format$(HVB8,"%g") ; "v";
  Print @(35,210)  "       "; @(35,210)  Format$(HVB9,"%g") ; "v";
  Print @(155,210) "       "; @(155,210) Format$(HVB10,"%g"); "v";
  Print @(35,230)  "       "; @(35,230)  Format$(HVB11,"%g"); "v";
  Print @(155,230) "       "; @(155,230) Format$(HVB12,"%g"); "v";
  Print @(35,250)  "       "; @(35,250)  Format$(HVB13,"%g"); "v";
  Print @(155,250) "       "; @(155,250) Format$(HVB14,"%g"); "v";
  Print @(50, 297) "       "; @(50,297)  Format$(HVBT,"%g");  " volts";
End Sub



'''''''''''''
' MAIN Starts here
Cls
LoadBMP "logo.bmp",30,30
Pause 1000 
Cls 
printHeader() 
setrelays() 
looper = 0
Chconfig()
Do
  K$ = Inkey$
  If K$ = "q" Then Exit
  If If (pidrequest21CE()=1) Then updateF5()
  Font 2
  Print @(260,404) looper; 
  looper = looper + 1
  If looper => 6 Then looper = 0 
Loop

CAN FREE
Cls
Print "        CANPORT CLOSED"
