' DISCLAIMER - USE AT OWN RISK

Dim R1 : Dim R2 : Dim R3 : Dim R4 : Dim K$ : Dim looper : R1 = 0
Dim IR1 : Dim IR2 : Dim IR3 : Dim IR4 : Dim IR5 : Dim IR6 : Dim IR7 : Dim IR8 : Dim IR9
Dim IR10 : Dim IR11 : Dim IR12 : Dim IR13 : Dim IR14 : Dim IRT : Dim ok : Dim txOk : Dim rxOk
R4 = 0


Sub Chconfig
  CAN CONFIG ok
  CAN SETSPEED 500000, ok
  CAN ADDTXCHNL 0,1,txOk
  CAN ADDRXCHNL 1,&h7EB,0,1,rxOk         
  CAN ENABLE ok
End Sub


Sub setrelays
  SetPin 15,9 : SetPin 16,9 : SetPin 17,9 : SetPin 18,9
  Pin(15) = 0 : Pause 10    : Pin(15) = 1
  Pin(16) = 1 : Pin(17) = 1 : Pin(18) = 1 : Pause 1000 : Pin(18) = R4
End Sub


Sub Filter21D0
  Local rxData(8) : Local rxOk
  CAN RX 1, rxData(8), rxOk
  If rxok = 1 Then
    If D3 = 0 And (rxData(0) = &H22) Then
      D3 = 1 : IR1 = 0.001 * rxData(5) : IR2 = 0.001 * rxData(6) : IR3 = 0.001 * rxData(7)
    EndIf
    If D4 = 0 And (rxData(0) = &H23) Then
      D4 = 1 : IR4 = 0.001 * rxData(1) : IR5 = 0.001 * rxData(2) : IR6 = 0.001 * rxData(3)
      IR7 = 0.001 * rxData(4) : IR8 = 0.001 * rxData(5) : IR9 = 0.001 * rxData(6)
      IR10 = 0.001 * rxData(7)
    EndIf
    If D5 = 0 And (rxData(0) = &H24) Then
      D5 = 1 : IR11 = 0.001 * rxData(1) : IR12 = 0.001 * rxData(2) : IR13 = 0.001 * rxData(3)
      IR14 = 0.001 * rxData(4)
    EndIf
  EndIf
End Sub


Function pidrequest21D0
  ' Function to get 14 x HV battery block internal resistances
  Local onLoop : Local bloop
  Local rxData(8) : Local rxOk
  Dim d1 : Dim d2 : Dim d3 : Dim d4 : Dim d5 : Local txData(8) : Local txok
  d1=0 : d2=0 : d3=0 : d4=0 : d5=0 : onLoop = 0 : bloop = 0 : pidrequest = 0
  txData(3) = 0 : txData(4) = 0 : txData(5) = 0 : txData(6) = 0 : txData(7) = 0
  txData(0) = &H2 : txData(1) = &H21 : txData(2) = &HD0
Do
  d1=0 : d2=0 : d3=0 : d4=0 : d5=0 : CAN TX 0, &H7E3, 0, 8, txData(), txOk
  If txok = 1 Then
    D1 = 1 : CAN RX 1, rxData(8), rxOk
    If rxOk = 1 Then
      If (rxData(0) = &H10) Then
        txData(0)=&H30 : txData(1)=0 : txData(2)=1
        Do
          CAN TX 0, &H7E3, 0, 8, txData(), txOk
          If txOk = 1 Then
            If D3 = 0 Or D4 = 0 Or D5 = 0 Then filter21D0()
            If D3 = 0 Or D4 = 0 Or D5 = 0 Then filter21D0()
            If D3 = 0 Or D4 = 0 Or D5 = 0 Then filter21D0()
            If D3=1 And D4=1 And D5=1 Then
              IRT = IR1+IR2+IR3+IR4+IR5+IR6+IR7+IR8+IR9+IR10+IR11+IR12+IR13+IR14
              pidrequest21D0 = 1 : CAN DISABLE ok : Exit Function
            EndIf
            bloop = bloop + 1
            IRT = IR1+IR2+IR3+IR4+IR5+IR6+IR7+IR8+IR9+IR10+IR11+IR12+IR13+IR14
            If bloop > 120 Then CAN DISABLE ok : Exit Function
          EndIf
        Loop
      EndIf
    EndIf
  EndIf
  If D3=1 And D4=1 And D5=1 Then
    IRT = IR1+IR2+IR3+IR4+IR5+IR6+IR7+IR8+IR9+IR10+IR11+IR12+IR13+IR14
    pidrequest21CE = 1 : CAN DISABLE ok : Exit Function
  EndIf
  IRT = IR1+IR2+IR3+IR4+IR5+IR6+IR7+IR8+IR9+IR10+IR11+IR12+IR13+IR14
  If onloop > 120 Then CAN DISABLE ok : Exit Function
  onLoop = onLoop + 1
Loop
End Function


Sub updateF6
  Font 2
  Print @(35,130)  "       "; @(35,130) Format$(IR1,"%g")  ; "";
  Print @(155,130) "       "; @(155,130) Format$(IR2,"%g") ; "";
  Print @(35,150)  "       "; @(35,150) Format$(IR3,"%g")  ; "";
  Print @(155,150) "       "; @(155,150) Format$(IR4,"%g") ; "";
  Print @(35,170)  "       "; @(35,170) Format$(IR5,"%g")  ; "";
  Print @(155,170) "       "; @(155,170) Format$(IR6,"%g") ; "";
  Print @(35,190)  "       "; @(35,190) Format$(IR7,"%g")  ; "";
  Print @(155,190) "       "; @(155,190) Format$(IR8,"%g") ; "";
  Print @(35,210)  "       "; @(35,210) Format$(IR9,"%g")  ; "";
  Print @(155,210) "       "; @(155,210) Format$(IR10,"%g"); "";
  Print @(35,230)  "       "; @(35,230) Format$(IR11,"%g") ; "";
  Print @(155,230) "       "; @(155,230) Format$(IR12,"%g"); "";
  Print @(35,250)  "       "; @(35,250) Format$(IR13,"%g") ; "";
  Print @(155,250) "       "; @(155,250) Format$(IR14,"%g"); "";
  Print @(50, 297) "       "; @(50,297)  Format$(IRT,"%g") ; " ohms";
End Sub


'''''''''''''
' MAIN Starts here
Cls
LoadBMP "logo.bmp",30,30
Pause 1000 
Cls 
printHeader() 
setrelays() 
looper = 0
Chconfig()
Do
 K$ = Inkey$
  If K$ = "q" Then Exit
  If If (pidrequest21D0()=1) Then updateF6()
  Font 2
  Print @(260,404) looper; 
  looper = looper + 1
  If looper => 6 Then looper = 0 
Loop

CAN FREE
Cls
Print "        CANPORT CLOSED"
